routes/admin.php
<?php
// Emails tests
// Route::get('mailable', function () {
//     $user = App\User::find(1);
//     return new App\Mail\AdminNewUser($user);
// });
// Admin specific routes
Route::get('/', ['as' => 'root', 'uses' => 'ArticlesController@index']);
Route::get('users/getdata', 'UsersController@getDataTable')->name('users.getdata');
Route::resource('users', 'UsersController');
Route::get('roles/getdata', 'RoleController@getDataTable')->name('roles.getdata');
Route::resource('roles', 'RoleController');
Route::get('permissions/getdata', 'PermissionController@getDataTable')->name('permissions.getdata');
Route::resource('permissions', 'PermissionController');
Route::resource('roles', 'RoleController');
Route::get('articles/getdata', 'ArticlesController@getDataTable')->name('articles.getdata');
Route::resource('articles', 'ArticlesController');


Route::get('pages/{parent_id}/getdata', 'PagesController@getDataTable')->name('pages.getdata');
Route::resource('pages', 'PagesController', ['except' => ['create', 'index']]);
Route::get('pages/{parent_id}/create', 'PagesController@create')->name('pages.create');
Route::get('pages/{parent_id?}/index', 'PagesController@index')->name('pages.index');
Route::post('pages/reorder/{id}', 'PagesController@reorder')->name('pages.reorder');
Route::resource('settings', 'SettingsController');
//taxonomies
Route::get('taxonomies/getdata', 'TaxonomiesController@getDataTable')->name('taxonomies.getdata');
Route::resource('taxonomies', 'TaxonomiesController', ['except' => ['create']]);
Route::get('taxonomies/create/{parent_id}', 'TaxonomiesController@create')->name('taxonomies.create');
Route::post('taxonomies/reorder/{id}', 'TaxonomiesController@reorder')->name('taxonomies.reorder');
Route::post('{table_type}/reorder', 'AdminController@orderObject')->name('reorder');
// Medias
Route::get('medias/getdata', 'MediasController@getDataTable')->name('medias.getdata');
Route::delete('medias/quickdestroy', 'MediasController@quickDestroy')->name('medias.quickdestroy');
Route::resource('medias', 'MediasController');
Route::get('getMediasFromArticle/{model_type}/{model_id}/{collection_name}', 'MediasController@getMediasFromArticle')->name('medias.article');
Route::post('medias/ajaxStore/{mediatable_type}/{article_id?}', 'MediasController@ajaxStore')->name('medias.ajaxstore');
Route::get('medias/ajaxGet/{id}', 'MediasController@ajaxGet')->name('medias.ajaxget');
Route::post('medias/reorder/{model_type}/{article_id}/{collection_name}', 'MediasController@reorder')->name('medias.reorder');
Route::post('medias/setfocalpoint', 'MediasController@setFocalPoint')->name('medias.setfocal');
// Route::post('medias/get', 'MediasController@getFromArray');
Route::post('medias/AjaxMediaUpdate/{mediatable_type}', 'MediasController@AjaxMediaUpdate')->name('medias.ajaxmediaupdate');
Route::post('fileupload', 'MediasController@fileUpload')->name('fileupload');
// Datatables
Route::get('datatable', 'DataTablesController@datatable');
Route::get('datatable/getArticles', 'DataTablesController@getArticles')->name('datatable/getdata');

routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Auth
Auth::routes();

// Language switcher
Route::get('lang/{language}', ['as' => 'lang.switch', 'uses' => 'LocaleController@switch']);
// Homepage
Route::get('/', 'HomeController@index')->name('homepage');
// Pages index
Route::get('/pages/{article_slug}', 'PagesController@show')->name('pages.show');
Route::get('/pages', 'PagesController@show')->name('pages.index');
// Article : view
Route::get('/{article_slug}', 'ArticlesController@show')->name('articles.show');

resources/views/admin/templates/articles-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
<div class="panel panel-default">
  <div class="table-responsive">
    @include('admin.components.datatable-loading')
    <a href="{{ route('admin.articles.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a>
    <table class="panel-body table table-hover table-bordered table-striped table-reorderable" id="datatable" style="width:100%">
      <?php // TODO: THEAD caché, à afficher selon les besoins + ajouter flèches si tri par colonne ?>
        <thead class="hidden">
          <tr>
            <th class="is-published"></th>
            <th class="main-column">Title</th>
            <th class="hidden-small">Updated</th>
            <th></th>
          </tr>
        </thead>
    </table>
  </div>
</div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      iDisplayLength: 50,
      stateSave: true,
      rowReorder: {
          selector: '.reorder'
      },
      colReorder: false,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('div.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata') }}',
      language: {
        'search': '',
        'searchPlaceholder': '{{ $data['page_title'] }}',
        'paginate': {
          'previous': '&larr;',
          'next': '&rarr;'
        },
        'lengthMenu': "{{__('admin.datatable_lengthMenu')}}",
        'zeroRecords': "{{__('admin.datatable_zeroRecords')}}",
        'info': "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'order', render: function ( data, type, row, meta ) {
          var this_class = 'fa-circle-o';
          if(row.published == 1){this_class = 'fa-circle '};
          return '<span class="bg-color" style="background:' +row.color+  '"></span><i class="fa icon-published '+ this_class +'" title="{{__('admin.not_published')}}"></i>';

        }, name: 'order', searchable: false,  orderable: false, class: 'is-published'},
        {data: 'title_link', render: function ( data, type, row, meta ) {
          return data;
        }, name: 'title', orderable: false, class: 'main-column'},
        {data: 'updated_at', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'updated_at', searchable: false, orderable: false, class: 'hidden-small updated_at'},
        {data: 'action', render: function ( data, type, row, meta ) {
          return data + '<i class="fa fa-sort reorder"></i>';
        }, name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {
        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            // $.each(json, function (key, msg) {
        	  // // handle json response
            // });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';
});
</script>
@endsection

resources/views/admin/templates/medias-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
<div class="panel panel-default">
  <div class="table-responsive">
    @include('admin.components.datatable-loading')
    {{-- <a href="{{ route('admin.medias.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a> --}}
    <table class="table table-hover table-bordered table-striped" id="datatable" style="width:100%">
        <thead class="hidden">
          <tr>
            <th class="media-preview"></th>
            <th class="main-column">Name</th>
            <th class="hidden-small">Dimensions</th>
            <th></th>
          </tr>
        </thead>
    </table>
  </div>
</div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      rowReorder: false,
      colReorder: false,
      iDisplayLength: 50,
      stateSave: true,
      dom       : '<"panel-heading"f> <"panel-body panel-body--medias"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata') }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $data['page_title'] }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'img', render: function ( data, type, row, meta ) {
          if(row.mime_type.includes("image", 0)){
            return '<img src="'+ data +'">';
          }else if(row.mime_type.includes("pdf", 0)){
            return '<div><span>PDF</span></div>';
          }else if(row.mime_type.includes("video", 0)){
            return '<div><span>VIDEO</span></div>';
          }else if(row.mime_type.includes("text", 0)){
            return '<div><span>TEXT</span></div>';
          }else{
            return '<div><span>FILE</span></div>';
          }
        }, class: 'media-preview'},
        {data: 'name', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'name', orderable: false, class: 'main-column'},
        {data: 'custom_properties', render: function ( data, type, row, meta ) { if(row.width){return row.width +' &times; '+ row.height}else{return null}}, name: 'custom_properties', orderable: false, class: 'hidden-small'},
        {data: 'action', name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {

        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            $.each(json, function (key, msg) {
        	  // handle json response
          });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';

});
</script>
@endsection

resources/views/admin/templates/pages-index.blade.php
<?php
  if(!empty($parent_article)):
    $parent_id = $parent_article->id;
    $page_title = $parent_article->title;
    $bt_add_label = __('admin.add_subpage');
  else:
    $parent_id = 0;
    $page_title = $data['page_title'];
    $bt_add_label = __('admin.add');
  endif;
?>

@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  <div class="panel panel-default">
    @if($parent_id > 0)
      <a href="{{ route('admin.' .$data['table_type']. '.index', 0) }}" class="link link__back">← Pages</a>
    @endif
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.pages.create', $parent_id) }}" class="btn btn-primary btn-xs">{{ $bt_add_label }}</a>
      <table class="panel-body table table-hover table-bordered table-striped table-reorderable" id="datatable" style="width:100%">
          <thead class="hidden">
            <tr>
              <th class="is-published"></th>
              <th class="main-column">Title</th>
              <th class="hidden-small"></th>
              <th></th>
            </tr>
          </thead>
      </table>
    </div>
  </div>

@endsection

@section('meta')
  <meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
function format ( parent ) {
  // `d` is the original data object for the row
  var request = '{{ route('admin.' .$data['table_type']. '.getdata', ':id') }}';
  request = request.replace(':id', parent.id);
  var h;
  $.ajaxSetup({async:false});
  $.get(request, function(data) {
    var data = data.data;
    if (data.length > 0) {
      h = '<table>';
      for(var i = 0; i < data.length; i++) {
        h += '<tr>';
        if(data[i].published == 1){
          h += '<td class="is-published"><i class="fa fa-circle icon-published"  title="{{__('admin.published')}}"></i></td>';
        }else {
          h += '<td class="is-published"><i class="fa fa-circle-o icon-published"  title="{{__('admin.not_published')}}"></i></td>';
        }
        h += '<td class="main-column"><div class="text-content">'+ data[i].title +'</div></td>';
        var edit = '{{ route('admin.pages.edit', ':id') }}';
        edit = edit.replace(':id', data[i].id);
        h += '<td><a href="'+ edit +'" class="link"> {{__('admin.edit')}}</a></td>';
        h += '</td>';
      }
      h += '</table>';
    }
  });
  $.ajaxSetup({async:true});
  return h;
}

$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      iDisplayLength: 50,
      stateSave: true,
      rowReorder: {
          selector: '.reorder'
      },
      colReorder: false,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata', $parent_id) }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $page_title }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'order', render: function ( data, type, row, meta ) {
          if(row.published == 1){
            return '<i class="fa fa-circle icon-published" title="{{__('admin.published')}}"></i>';
          }else {
            return '<i class="fa fa-circle-o icon-published" title="{{__('admin.not_published')}}"></i>';
          }
        }, name: 'order', searchable: false, class: 'is-published'},
        {data: 'title', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'title', orderable: false, class: 'main-column'},
        {data: 'updated_at', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'updated_at', searchable: false, orderable: false, class: 'hidden-small updated_at'},
        {data: 'action', render: function ( data, type, row, meta ) {
          return data + '<i class="fa fa-sort reorder"></i>';
        }, name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {
        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            $.each(json, function (key, msg) {
        	  // handle json response
          });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';

    // Add event listener for opening and closing details
    $('#datatable tbody').on('click', '.has-child .main-column', function () {
        var tr = $(this).closest('tr');
        var row = table.row(tr);
        if ( row.child.isShown() ) {
            // This row is already open - close it
            row.child.hide();
            tr.removeClass('shown');
        }
        else {
            // Open this row
            row.child( format(row.data()) ).show();
            tr.addClass('shown');
            tr.next().addClass('datatable-child');
        }
    } );
});
</script>
@endsection

resources/views/admin/templates/permissions-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  <div class="panel panel-default">
    <div class="table-responsive">
      <a href="{{ route('admin.permissions.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a>
      <table class="panel-body table table-hover table-bordered table-striped" style="width:100%" id="datatable">
        <thead>
          <tr>
            <th>Permissions</th>
            <th></th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection


@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      processing: true,
      serverSide: true,
      rowReorder: false,
      colReorder: false,
      paging:   false,
      stateSave: true,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata') }}',
      language: {
        "search": '',
        searchPlaceholder: "Permissions",
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'name', name: 'name', orderable: false, width: '60%'},
        {data: 'action', name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });
    $.fn.dataTable.ext.errMode = 'throw';

});
</script>
@endsection

resources/views/admin/templates/roles-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  @include('admin.components.flash-message')
  <div class="panel panel-default">
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.roles.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a>
      <table class="panel-body table table-hover table-bordered table-striped" style="width:100%" id="datatable-roles">
        <thead class="hidden">
          <tr>
            <th>Roles</th>
            <th></th>
            <th></th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
  <div class="panel panel-default">
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.permissions.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a>
      <table class="panel-body table table-hover table-bordered table-striped" style="width:100%" id="datatable-permissions">
        <thead class="hidden">
          <tr>
            <th>Permissions</th>
            <th></th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">

$(document).ready(function() {
    var table_roles = $('#datatable-roles').DataTable({
      responsive: true,
      processing: true,
      serverSide: true,
      rowReorder: false,
      colReorder: false,
      paging:   false,
      stateSave: true,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('#datatable-roles_wrapper').siblings('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.roles.getdata') }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $data['page_title'] }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'name', name: 'name', orderable: false, class: 'main-column'},
        {data: 'updated_at', name: 'title', searchable: false, orderable: false, class: 'hidden-small'},
        {data: 'action', name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });
  var table_permissions = $('#datatable-permissions').DataTable({
      responsive: true,
      processing: true,
      serverSide: true,
      rowReorder: false,
      colReorder: false,
      paging:   false,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('#datatable-permissions_wrapper').siblings('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.permissions.getdata') }}',
      language: {
        "search": '',
        searchPlaceholder: "Permissions",
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
      },
      columns: [
        {data: 'name', name: 'name', orderable: false, class: 'main-column'},
        {data: 'action', name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });
    $.fn.dataTable.ext.errMode = 'throw';

});
</script>
@endsection

resources/views/admin/templates/taxonomies-index.blade.php
<?php // TODO: Debug no Taxonomies results actually ?>

@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  @if($taxonomies) @foreach ($taxonomies as $taxonomy)
  <div class="panel panel-default">
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.taxonomies.create', $taxonomy->id) }}" class="btn btn-primary btn-xs"> Add</a>
      <table class="panel-body table table-hover table-bordered table-striped table-reorderable" style="width:100%" id="datatable-{{$taxonomy->id}}">
        <thead class="hidden">
          <tr>
            <th>{{ $taxonomy->name }}</th>
            <th></th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
  @endforeach @endif
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    @if($taxonomies) @foreach ($taxonomies as $taxonomy)
      var table_{{$taxonomy->id}} = $('#datatable-{{$taxonomy->id}}').DataTable({
        'responsive': false,
        'processing': true,
        'serverSide': true,
        'iDisplayLength': 50,
        'stateSave': true,
        'rowReorder': {
            selector: '.reorder'
        },
        'colReorder': false,
        'paging':   false,
        'dom'       : '<"panel-heading"f> <"panel-body"t> <"panel-footer">',
        'initComplete': function(settings, json) {
            $('#datatable-{{$taxonomy->id}}_wrapper').siblings('.datatable-loading').hide();
          },
        'ajax': {
          'url': '{{ route('admin.' .$data['table_type']. '.getdata') }}',
          'data': function ( d ) {
              d.parent_id = {{$taxonomy->id}};
          }
        },
        language: {
          'search': '',
          'searchPlaceholder': '{{ $taxonomy->name }}',
          'paginate': {
            'previous': '&larr;',
            'next': '&rarr;'
          },
          lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
          zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
          info: "{{__('admin.datatable_info')}}",
        },
        columns: [
          {data: 'name', render: function ( data, type, row, meta ) {
            return '<div class="text-content">'+ data + '</div>';
          }, name: 'name', orderable: false, class: 'main-column'},
          {data: 'action', render: function ( data, type, row, meta ) {
            return data + '<i class="fa fa-sort reorder"></i>';
          }, name: 'action', orderable: false, searchable: false, class:'faded'}
        ]
      });

      $.fn.dataTable.ext.errMode = 'throw';

      table_{{$taxonomy->id}}.on( 'row-reorder', function ( e, diff, edit ) {
        var articlesArray = [];
        for ( var i=0, ien=diff.length ; i<ien ; i++ ) {

          var rowData = table_{{$taxonomy->id}}.row( diff[i].node ).data();
          var newOrder = diff[i].newPosition;
          articlesArray.push({
            id: rowData.id,
            position: newOrder
          });
        }
        var jsonString = JSON.stringify(articlesArray);
        $.ajax({
          url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
          type    : 'POST',
          data    : jsonString,
          dataType: 'json',
          success : function ( json ) {
            $('#datatable-{{$taxonomy->id}}').DataTable().ajax.reload(); // refresh datatable
              $.each(json, function (key, msg) {
              // handle json response
            });
          }
        });
      });
      $.fn.dataTable.ext.errMode = 'throw';
    @endforeach @endif
});
</script>
@endsection